# $Revision: 1.67 $, $Date: 2012/07/04 07:20:37 $
# NOTE
# - Warning: tests will fail if at same time tests are running (shared hw for
#   builders) as fixed port 20059 is used.
# - Warning: tests will fail inside vserver as binding to localhost, peername
#   is not 127.0.0.1 (will be ip of interfaces/0/ip instead)
#
# Conditional build:
%bcond_without	tests	# don't run tests
#
%define         webapp          hgweb
%define         webappdir       %{_sysconfdir}/webapps/%{webapp}
%define         appdir          %{_datadir}/%{webapp}
%define         cgibindir       %{_prefix}/lib/cgi-bin

Summary:	Mercurial Distributed SCM
Summary(pl.UTF-8):	Mercurial - rozproszony SCM
Name:		mercurial
Version:	2.2.3
Release:	1
License:	GPL v2
Group:		Development/Version Control
Source0:	http://mercurial.selenic.com/release/%{name}-%{version}.tar.gz
# Source0-md5:	f4c70af3892d964b83b2718bde44c2f8
Source1:	gtools.py
Source2:	%{name}-%{webapp}.config
# TODO: provide default config
Source3:	%{name}-%{webapp}-httpd.config
Patch0:		%{name}-doc.patch
URL:		http://mercurial.selenic.com/
BuildRequires:	asciidoc
BuildRequires:	gettext-devel
BuildRequires:	python >= 1:2.4
BuildRequires:	python-devel
BuildRequires:	python-docutils
BuildRequires:	python-pygtk-gtk
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
%{?with_tests:BuildRequires:	unzip}
BuildRequires:	xmlto
%pyrequires_eq	python-modules
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Mercurial is a fast, lightweight source control management system
designed for efficient handling of very large distributed projects.
Features include:
- O(1) delta-compressed file storage and retrieval scheme
- Complete cross-indexing of file and changesets for efficient
  exploration of project history
- Robust SHA1-based integrity checking and append-only storage model
- Decentralized development model with arbitrary merging between trees
- High-speed HTTP-based network merge protocol
- Easy-to-use command-line interface
- Integrated stand-alone web interface
- Small Python codebase
- GPL license

%description -l pl.UTF-8
Mercurial to szybki, lekki system zarządzania kodem źródłowym
zaprojektowany do wydajnej obsługi bardzo dużych rozproszonych
projektów. Możliwości obejmują:
- przechowywanie skompresowanych plików różnic i schemat odtwarzania
  O(1)
- pełne indeksowanie plików i zmian w celu szybkiego przeglądania
  historii projektu
- silne, oparte na SHA1 sprawdzanie integralności oraz model
  przechowywania z samym dołączaniem
- zdecentralizowany model rozwoju z dowolnym łączeniem między drzewami
- szybki protokół łączenia po sieci oparty na HTTP
- łatwy w użyciu interfejs linii poleceń
- zintegrowany samodzielny interfejs WWW
- mały kod podstawowy w Pythonie
- licencja GPL

%package hgweb
Summary:	Scripts for serving mercurial repositories over HTTP
Summary(pl.UTF-8):	Skrypty do serwowania repozytoriów mercuriala przez HTTP
Group:		Development/Version Control
Requires:	%{name} = %{version}-%{release}
Requires:	apache-mod_wsgi >= 1.1
Requires:	webapps

%description hgweb
CGI scripts for serving mercurial repositories

%description hgweb -l pl.UTF-8
Skrypty CGI do serwowania repozytorió w mercuriala

%package hgk
Summary:	GUI for mercurial
Summary(pl.UTF-8):	Graficzny interfejs użytkownika dla systemu Mercurial
Group:		Development/Version Control
Requires:	%{name} = %{version}-%{release}
%pyrequires_eq	python-modules

%description hgk
A tool called that allows browsing the history of a repository in a
GUI.

To enable it add to .hgrc file:
[extensions]
hgk=

%description hgk -l pl.UTF-8
Narzędzie pozwalające na przeglądanie historii repozytorium w
graficznym interfejsie użytkownika.

Aby je uaktywnić, należy dodać do pliku .hgrc:
[extensions]
hgk=

%prep
%setup -q
%patch0 -p1
install %{SOURCE1} hgext/gtools.py

%build
%{__python} setup.py build
%{__make} -C doc

%{?with_tests:cd tests && %{__python} run-tests.py --verbose}

%install
rm -rf $RPM_BUILD_ROOT

%{__python} setup.py install \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{cgibindir}
install *.cgi $RPM_BUILD_ROOT%{cgibindir}/

install -d $RPM_BUILD_ROOT%{webappdir}
install %{SOURCE2} $RPM_BUILD_ROOT%{webappdir}/%{webapp}.config

> $RPM_BUILD_ROOT%{webappdir}/httpd.conf
> $RPM_BUILD_ROOT%{webappdir}/apache.conf

install contrib/hgk $RPM_BUILD_ROOT%{_bindir}

install -d $RPM_BUILD_ROOT%{_mandir}/man{1,5}
install doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
install doc/*.5 $RPM_BUILD_ROOT%{_mandir}/man5

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin hgweb -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{webapp}

%triggerun hgweb -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{webapp}

%triggerin hgweb -- apache < 2.2.0, apache-base
%webapp_register httpd %{webapp}

%triggerun hgweb -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{webapp}

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS README
%attr(755,root,root) %{_bindir}/hg
%{py_sitedir}/hgext
%dir %{py_sitedir}/%{name}
%attr(755,root,root) %{py_sitedir}/%{name}/*.so
%{py_sitedir}/%{name}/*.py[co]
%{py_sitedir}/%{name}/help
%{py_sitedir}/%{name}/hgweb
%{py_sitedir}/%{name}/httpclient
%{py_sitedir}/%{name}/templates
%dir %{py_sitedir}/%{name}/locale
%lang(da) %{py_sitedir}/%{name}/locale/da
%lang(de) %{py_sitedir}/%{name}/locale/de
%lang(el) %{py_sitedir}/%{name}/locale/el
%lang(fr) %{py_sitedir}/%{name}/locale/fr
%lang(it) %{py_sitedir}/%{name}/locale/it
%lang(ja) %{py_sitedir}/%{name}/locale/ja
%lang(pt_BR) %{py_sitedir}/%{name}/locale/pt_BR
%lang(ro) %{py_sitedir}/%{name}/locale/ro
%lang(ru) %{py_sitedir}/%{name}/locale/ru
%lang(sv) %{py_sitedir}/%{name}/locale/sv
%lang(zh_CN) %{py_sitedir}/%{name}/locale/zh_CN
%lang(zh_TW) %{py_sitedir}/%{name}/locale/zh_TW
%if "%{py_ver}" > "2.4"
%{py_sitedir}/*.egg-info
%endif
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*

%files hgweb
%defattr(644,root,root,755)
%dir %{cgibindir}
%attr(755,root,root) %{cgibindir}/*.cgi
%dir %{webappdir}
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/apache.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/hgweb.config
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/httpd.conf

%files hgk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/hgk

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mercurial.spec,v $
Revision 1.67  2012/07/04 07:20:37  kiesiu
- updated to 2.2.3

Revision 1.66  2012/06/11 14:19:28  kiesiu
- updated to 2.2.2

Revision 1.65  2012/04/05 08:17:28  zawadaa
- up to 2.1.2

Revision 1.64  2012/03/11 22:22:21  zawadaa
- add BR: python-pygtk-gtk - thanks arekm in this investigation
- STBR

Revision 1.63  2012/03/11 20:42:22  zawadaa
- up to 2.1.1

Revision 1.62  2012/01/17 21:32:55  kiesiu
- updated to 2.0.2

Revision 1.61  2011/12/04 12:16:18  kiesiu
- updated to 2.0.1

Revision 1.60  2011/10/13 19:01:05  zawadaa
- up to 1.9.3
- long waiting patches ;-) - build mercurial-hgweb - for hg servers
- I don't know is this proper way but works 2 years

Revision 1.59  2011/09/04 19:49:47  kiesiu
- updated to 1.9.2

Revision 1.58  2011/07/02 20:31:16  arekm
- up to 1.9

Revision 1.57  2011/04/01 18:42:06  arekm
- up to 1.8.2

Revision 1.56  2010/12/03 19:04:24  arekm
- up to 1.7.2

Revision 1.55  2010/07/08 12:11:02  arekm
- up to 1.6

Revision 1.54  2010/07/08 07:55:03  arekm
- release 2

Revision 1.53  2010/05/04 13:55:18  baggins
- 1.5.2

Revision 1.52  2010/03/06 17:00:21  arekm
- up to 1.5

Revision 1.51  2010/02/02 20:06:18  arekm
- up to 1.4.3

Revision 1.50  2010/02/02 19:48:04  arekm
- up to 1.4.2

Revision 1.49  2009/12/04 16:56:26  sparky
- BR: gettext-devel and unzip for tests

Revision 1.48  2009/12/04 12:28:53  arekm
- up to 1.4.1

Revision 1.47  2009/11/18 03:02:38  arekm
- up to 1.4

Revision 1.46  2009/07/03 08:00:49  arekm
- up to 1.3

Revision 1.45  2009/03/23 16:38:20  zawadaa
- up to 1.2.1

Revision 1.44  2009/03/05 19:19:53  arekm
- up to 1.2

Revision 1.43  2009/01/02 00:07:51  arekm
- up to 1.1.2

Revision 1.42  2008/12/21 13:26:43  arekm
- up to 1.1.1

Revision 1.41  2008/12/04 07:44:01  arekm
- up to 1.1

Revision 1.40  2008/10/06 09:23:27  pawelz
- BR: python-devel

Revision 1.39  2008/10/03 17:45:08  arekm
- release 2

Revision 1.38  2008/08/17 20:53:54  arekm
- up to 1.0.2

Revision 1.37  2008/08/14 16:13:32  arekm
- release 3

Revision 1.36  2008-06-11 15:49:34  hawk
- release 2

Revision 1.35  2008-06-05 13:47:29  pluto
- updated to 1.0.1.

Revision 1.34  2008-05-18 22:03:42  glen
- tests fail in vserver too

Revision 1.33  2008-05-18 22:02:03  glen
- tests use fixed port

Revision 1.32  2008-05-18 21:16:08  glen
- release 2

Revision 1.31  2008-05-18 21:15:54  glen
- build with 2.4 kernel

Revision 1.30  2008-04-15 16:49:38  qboosh
- formatting

Revision 1.29  2008-04-15 09:16:10  czarny
- gtools for mercurial

Revision 1.28  2008-03-30 21:03:35  arekm
- up to 1.0

Revision 1.27  2007/11/01 13:29:07  qboosh
- updated python BRs

Revision 1.26  2007/11/01 10:47:40  arekm
- up to 0.9.5

Revision 1.25  2007/07/01 12:26:06  qboosh
- bcond header
- sorted BRs

Revision 1.24  2007/07/01 09:05:42  arekm
- run tests

Revision 1.23  2007/07/01 09:01:04  arekm
- up to 0.9.4

Revision 1.22  2007/04/01 00:46:06  arekm
- up to 0.9.3

Revision 1.21  2007/02/13 06:46:53  glen
- tabs in preamble

Revision 1.20  2007/02/12 00:49:07  baggins
- converted to UTF-8

Revision 1.19  2006/12/19 22:42:52  qboosh
- reverted thinko

Revision 1.18  2006/12/17 19:05:17  ankry
- tabs

Revision 1.17  2006/12/17 09:47:11  rotom
- added BR, thx zenon

Revision 1.16  2006/12/16 23:58:42  rotom
- pldized, thx to zenon

Revision 1.15  2006/12/16 23:49:59  rotom
- up to 0.9.2
- BR added

Revision 1.14  2006/10/06 19:19:31  qboosh
- more files (pointed by arkh)

Revision 1.13  2006/10/06 16:08:54  qboosh
- added manuals (pointed by arkh)

Revision 1.12  2006/09/30 23:02:39  arekm
- rel 2

Revision 1.11  2006/09/12 05:56:59  glen
- clean unpackaged files

Revision 1.10  2006/09/11 22:42:55  aredridel
- 0.9.1

Revision 1.9  2006/04/08 08:36:07  arekm
- up to 0.8.1

Revision 1.8  2006/01/31 12:43:41  qboosh
- pl for -hgk

Revision 1.7  2006/01/30 23:21:15  arekm
- rel 2

Revision 1.6  2006/01/30 23:19:25  arekm
- put hgk in default search path

Revision 1.5  2006/01/30 23:10:11  arekm
- add GUI subpackage

Revision 1.4  2006/01/30 22:43:42  arekm
- updated to 0.8

Revision 1.3  2005/12/04 19:33:42  arekm
- up to 0.7

Revision 1.2  2005/08/02 22:18:11  qboosh
- pl

Revision 1.1  2005/07/31 18:17:47  arekm
- initial pld release (new SCM)
